import com.nttdocomo.ui.*;

public class m11RPGid_BGMPlayer implements MediaListener {

	AudioPresenter _player;

	private boolean _loop;

	private MediaSound _snd;

	private int _volume;

	public m11RPGid_BGMPlayer() {

	}

	public void setVolume(int vol) {

		if (_player != null && _volume < 1 && vol > 0) {
			_player.play();
		}

		_volume = vol;

		if (_player != null && vol < 1) {
			_player.stop();
		}

	}

	public boolean playBGM(byte[] data, boolean loop) {

		_loop = loop;

		if (data == null) {
			return false;
		}

		if (_player != null) {

			_player.setMediaListener(null);

			_player.stop();

			_player = null;

		}

		if (_snd != null) {

			try {

				_snd.unuse();
				_snd.dispose();

			} catch (Exception e) {
			}

			_snd = null;

		}

		_snd = MediaManager.getSound(data);

		try {
			_snd.use();
		} catch (Exception e) {
			_snd = null;
		}

		if (_snd == null) {
			return false;
		}

		if (_player == null) {
			_player = AudioPresenter.getAudioPresenter();
		}

		_player.setMediaListener(this);

		_player.setSound(_snd);

		if (_volume < 1) {
			return true;
		}

		_player.play();

		return true;

	}

	public void stop() {

		if (_player != null) {

			_player.setMediaListener(null);

			_player.stop();

			_player = null;

		}

		if (_snd != null) {

			try {

				_snd.unuse();
				_snd.dispose();

			} catch (Exception e) {
			}

			_snd = null;

		}

	}

	public void mediaAction(MediaPresenter src, int type, int param) {

		if (type == AudioPresenter.AUDIO_COMPLETE) {

			if (_snd != null && _loop) {
				_player.play();
			}

		}

	}

}
