import com.nttdocomo.ui.*;

public class m11RPGid_ItemDialog {

	public static final int STATUS_NONE = 0;
	public static final int STATUS_LIST_INIT = 1;
	public static final int STATUS_LIST = 2;
	public static final int STATUS_ITEM_INIT = 3;
	public static final int STATUS_ITEM = 4;
	public static final int STATUS_CANCELED = 5;

	public static final int RESULT_EQUIP = 1;
	public static final int RESULT_USE = 2;
	public static final int RESULT_DISPOSE = 3;

	private m11RPGid_PlayerItemHolder _itemHolder;

	private m11RPGid_SelectDialog _listDlg = new m11RPGid_SelectDialog();
	private m11RPGid_SelectDialog _itemDlg = new m11RPGid_SelectDialog();

	// bZ[WEChE
	private m11RPGid_MessageWindow _message = new m11RPGid_MessageWindow();

	private int _status;

	private int _x = 0;
	private int _y = 0;

	private int _itemIndex = -1;
	private m11RPGid_PlayerItem _item = null;

	public m11RPGid_PlayerItem resultItem = null;
	public int result = 0;

	private boolean _visible = false;

	public void setup(m11RPGid_PlayerItemHolder holder) {

		_itemHolder = holder;

		_visible = false;

		setupListDlg();

	}

	// ꗗ_CAOݒ
	public void setupListDlg() {

		String[] list = new String[1 + _itemHolder.getItemNum()];

		list[0] = "߂";

		// ǉ
		for (int i = 0;i < _itemHolder.getItemNum();i++) {

			// ȂE)̕t
			if (_itemHolder.getItem(i).equip) {
				list[1 + i] = "E)" + _itemHolder.getItem(i).name;
			} else {
				list[1 + i] = _itemHolder.getItem(i).name;
			}

		}

		_listDlg.setItems(list);
		_listDlg.reset();

		_listDlg.setCancelable(true);

		_listDlg.setPos(_x - _listDlg.getWidth(), _y - (_listDlg.getHeight() / 2));

	}

	public void reset() {

		_status = STATUS_LIST_INIT;

		_itemIndex = -1;
		_item = null;

		resultItem = null;

	}

	public void setPos(int x, int y) {

		_x = x;
		_y = y;

	}

	public boolean process(m11RPGid_KeyStatusHolder key) {

		int i = 0;
		String[] list;

		switch (_status) {

		// ꗗ_CAO
		case STATUS_LIST_INIT:

			setupListDlg();

			_status = STATUS_LIST;

			_listDlg.show();

			break;

		// ꗗ_CAOI
		case STATUS_LIST:

			if (_listDlg.process(key)) {

				switch (_listDlg.getIndex()) {

				// LZE߂
				case -1:
				case 0:

					_status = STATUS_CANCELED;

					_itemIndex = -1;
					_item = null;

					resultItem = null;

					return true;

				//@I
				default:

					// IʂL^
					_itemIndex = _listDlg.getIndex() - 1;

					// Iꂽ
					_item = _itemHolder.getItem(_itemIndex);

					// _CAO
					_status = STATUS_ITEM_INIT;

					break;

				}

			}

			break;

		// _CAO
		case STATUS_ITEM_INIT:

			// Iz쐬
			if (_item.type == m11RPGid_PlayerItem.ITEMTYPE_GOODS) {
				list = new String[3];
			} else {
				list = new String[4];
			}

			i = 0;

			list[i++] = "߂";

			// \ȓȂ瑕ǉ
			if (_item.type != m11RPGid_PlayerItem.ITEMTYPE_GOODS) {
				list[i++] = "";
			}

			list[i++] = "g";
			list[i++] = "̂Ă";

			_itemDlg.reset();

			_itemDlg.setItems(list);
			_itemDlg.setCancelable(true);

			_status = STATUS_ITEM;

			_itemDlg.setPos(_x, _y - (_itemDlg.getHeight() / 2));

			_itemDlg.show();

			break;

		// _CAOI
		case STATUS_ITEM:

			if (_itemDlg.process(key)) {

				switch (_itemDlg.getIndex()) {

				case -1:
				case 0:

					_status = STATUS_LIST_INIT;

					_itemDlg.hide();

					break;

				case 1:

					resultItem = _item;

					if (_item.type == m11RPGid_PlayerItem.ITEMTYPE_GOODS) {
						result = RESULT_USE;
					} else {
						result = RESULT_EQUIP;
					}

					_itemDlg.hide();

					return true;

				case 2:

					resultItem = _item;

					if (_item.type == m11RPGid_PlayerItem.ITEMTYPE_GOODS) {
						result = RESULT_DISPOSE;
					} else {
						result = RESULT_USE;
					}

					_itemDlg.hide();

					return true;

				case 3:

					resultItem = this._item;

					result = RESULT_DISPOSE;

//					_itemDlg.clear();
					_itemDlg.hide();

					return true;

				}

			}

			break;

		}

		return false;

	}

	public void show() {
		_visible = true;
	}

	public void hide() {
		_visible = false;
	}

	public void draw(Graphics g) {

		if (!_visible) {
			return;
		}

		_listDlg.draw(g);
		_itemDlg.draw(g);

	}

}
